<?php
/*
=====================================================
 LightState Ver. 3.0
-----------------------------------------------------
 Author : Артем Малков
 Translate: dlefa.ir
-----------------------------------------------------
 FileName :  engine/modules/lightstat.php
=====================================================
*/

if(!defined("DATALIFEENGINE")) {
	die("Hacking attempt!");
}

include("engine/api/api.class.php");

function sort_date_visit($a_new, $b_new) {

	return $b_new["3"] - $a_new["3"];

}

function isBot(&$botname = "") {

	$bots = array(
		"rambler", "aport", "yahoo", "msnbot", "turtle", "mail.ru", "omsktele", "yetibot",
		"picsearch", "sape.bot", "sape_context", "gigabot", "snapbot", "alexa.com", "megadownload.net", 
		"askpeter.info", "igde.ru", "ask.com", "qwartabot", "yanga.co.uk", "scoutjet", "similarpages",
		"oozbot", "shrinktheweb.com", "aboutusbot", "followsite.com", "dataparksearch", "liveinternet.ru",
		"xml-sitemaps.com", "agama", "metadatalabs.com", "h1.hrn.ru", "seo-rus.com", "yaDirectBot",
		"yandeG", "Copyscape.com", "domaintools.com", "Nigma.ru", "dotnetdotcom", "bing", "Accoona",
		"ia_archiver", "Ask Jeeves", "OmniExplorer_Bot", "W3C_Validator", "WebAlta", "Yahoo", "Ezooms",
		"Tourlentabot", "MJ12bot", "AhrefsBot", "SearchBot", "SiteStatus", "Baiduspider", "Statsbot",
		"SISTRIX", "AcoonBot", "findlinks", "proximic", "OpenindexSpider", "statdom.ru", "Exabot", "Spider",
		"SeznamBot", "oBot", "C-T bot", "Updownerbot", "Snoopy", "heritrix", "Yeti", "DomainVader",
		"DCPbot", "PaperLiBot", "a.pr-cy.ru", "eSyndiCat Bot", "YandexBot", "YandexImages", "YandexMetrika",
		"YaDirectFetcher", "YandexMobileBot", "YandexMarket", "YandexImageResizer", "Yandex Market picture robot",
		"YandexAccessibilityBot", "YandexCatalog", "Googlebot", "AdsBot-Google", "Mail.RU_Bot", "bingbot",
		"msnbot-media", "Baiduspider-", "Yahoo! Slurp", "curl", "SemrushBot", "price.ru-image-robot",
		"ltx71.com", "Riddler", "SurdotlyBot", "ActivizmBot", "glindahl-cocrawler", "Twitterbot",
		"facebookexternalhit", "Virusdie crawler", "Cliqzbot", "statdom.ru/Bot", "openstat.ru/Bot",
		"linkdexbot", "Linkbot", "coccocbot-web", "SMTBot", "top100.rambler.ru crawler", "WebMoney MegaStock robot",
		"CommonCrawler Node", "archive.org_bot", "SEOkicks-Robot", "TorgMailRuBot", "Python-urllib/2.7",
		"Yandex.Commerce.Pinger", "BLEXBot", "linux-gnu", "Googlebot-Image", "AdsBot-Google-Mobile",
		"360Spider", "Trident-не бот", "YisouSpider", "spider", "PHP-Curl-Class", "slurp", "crawler",
		"pinger", "robot", "WGet tools", "FavIconizer", "FaceBook bot", "CFNetwork", "NG 1.x (Exalead)",
		"Phantom", "RoadHouse Crawling System", "SurveyBot", "Perl tool", "Sogou Spider", "StackRambler",
		"TITAN", "Feedfetcher-Google", "Netcraft", "Fish search", "RBSE Spider", "Sift", "W3C Validator",
		"Konqueror", "Yahoo Slurp", "Mail.RU Bot", "archive.org bot", "Apache-HttpClient/", "Flamingo_SearchEngine",
		"Googlebot-Nes", "Googlebot-Images", "Googlebot-Video", "Google-Mobile", "Google-Mobile AdSense",
		"Google-AdSense", "Google-AdsBot", "Teoma", "Lycos", "Aport",
	);

	foreach($bots as $bot) {

		if(stripos($_SERVER["HTTP_USER_AGENT"], $bot) !== false) {

			$botname = $bot;

			return 2;

		}

	}

	return 0;

}

function number_user_e($number_user, $titles_user) {

	$cases = array(2, 0, 1, 1, 1, 2);

	return $titles_user[($number_user%100>4 && $number_user%100<20)? 2 : $cases[min($number_user%10, 5)]];

}

if(isset($member_id["user_id"])) {

	$type_user = 1;
	$db->query("UPDATE " . USERPREFIX . "_users SET `lastdate` = '".time()."' WHERE `user_id` = '".$member_id["user_id"]."'");

} else { 

	$type_user = isBot($bname);

}

$check_user = $db->query("SELECT * FROM dlefa_lightstat WHERE `ip` = '".md5($_SERVER['REMOTE_ADDR'])."'");

if($check_user->num_rows > 0) {

	$db->query("UPDATE dlefa_lightstat SET `time` = '".time()."' WHERE `ip`= '".md5($_SERVER['REMOTE_ADDR'])."'");

} else {

	$db->query("INSERT IGNORE INTO dlefa_lightstat VALUES ('".md5($_SERVER['REMOTE_ADDR'])."', '".time()."', '".$type_user."')");

}

$result_numb = "";
$result_numb_percent = "";

$numb_online = 0;
$user_numb = 0;
$guest_numb = 0;
$bot_numb = 0;

$cache_lighstat = $dle_api->load_from_cache("cache_lighstat",  15, "text"); 

if($cache_lighstat === false) {

	$db->query("DELETE FROM dlefa_lightstat WHERE `time` + '180' < ".time());

	$user_list_type = $db->query("SELECT * FROM dlefa_lightstat");

	while($row = $db->get_row($user_list_type)) {

		$numb_online++;

		if($row["type"] == "1") {

			$user_numb++;

		} else if($row["type"] == "0") {

			$guest_numb++;

		} else if($row["type"] == "2") {

			$bot_numb++;

		}

	}

	$numb_online_head = number_format($numb_online, 0, "", " ")." بازدید کننده";

	if($user_numb > 0) {

		$result_numb .= '<div class="lightstat_user"><span></span>کاربران عضو<span>'.number_format($user_numb, 0, "", " ").'</span></div>';
		$result_numb_percent .= '<span class="lightstat_user_circle" style="width: '.str_replace(",", ".", round(($user_numb / $numb_online * 100), 3)).'%"></span>';

	}

	if($guest_numb > 0) {

		$result_numb .= '<div class="lightstat_guest"><span></span>کاربران مهمان<span>'.number_format($guest_numb, 0, "", " ").'</span></div>';
		$result_numb_percent .= '<span class="lightstat_guest_circle" style="width: '.str_replace(",", ".", round(($guest_numb / $numb_online * 100), 3)).'%"></span>';

	}

	if($bot_numb > 0) {

		$result_numb .= '<div class="lightstat_bot"><span></span>ربات ها<span>'.number_format($bot_numb, 0, "", " ").'</span></div>';
		$result_numb_percent .= '<span class="lightstat_bot_circle" style="width: '.str_replace(",", ".", round(($bot_numb / $numb_online * 100), 3)).'%"></span>';

	}

	$user_list_visit = $db->query("SELECT name, user_id, user_group, lastdate, foto FROM " . USERPREFIX . "_users WHERE `lastdate` > ".(time() - 86400));

	$user_list_visit_last = [];

	while($row = $db->get_row($user_list_visit)) {

		if(date("m.d.Y", $row["lastdate"]) == date("m.d.Y")) {

			$user_list_visit_last[] = array($row["name"], $row["user_id"], $row["user_group"], $row["lastdate"], $row["foto"]);

		}

	}

	usort($user_list_visit_last, "sort_date_visit");

	$user_list_visit_item = "";

	if(count($user_list_visit_last) > 0) {

		foreach($user_list_visit_last as $key) {

			if(time() - $key[3] <= 180) {
				
				$online_now = "<span class=\"online\">آنلاین در سایت</span>";

			} else {

				if((time() - $key[3]) > 180 && (time() - $key[3]) <= 3540) {

					$minute = round(((time() - $key[3]) / 60));
					
					$online_now = "<span>".$minute." دقیقه پیش آنلاین بوده است!</span>";

				} else {
					
					$hour = round(((time() - $key[3]) / 60 / 60));

					$online_now = "<span>".$hour." ساعت پیش آنلاین بوده است!</span>";

				}

			}

			if($key[4] == "") {

				$avatar_link = "/templates/".$config["skin"]."/images/no_avatar_lightstat.png";

			} else {

				$avatar_link = $key[4];

			}

			if($config["allow_alt_url"] == 1) {

				$user_link = "/user/".$key[0];

			} else {

				$user_link = "/index.php?subaction=userinfo&user=".$key[0];

			}

			$user_list_visit_item .= '

				<div class="lightstat_user_list_item">

					<a href="'.$user_link.'" title="مشاهده پروفایل کاربر" class="lightstat_user_list_item_avatar" style="background: url('.$avatar_link.')"></a>
					<div class="lightstat_user_list_item_info group_id_'.$key[2].'">
						<a href="'.$user_link.'" title="مشاهده پروفایل کاربر">'.$key[0].'</a>
						'.$online_now.'
					</div>

				</div>

			';

		}

		if(count($user_list_visit_last) > 3) {

			$full_list_visit_link = '

				<div class="full_list_visit_bg">
					<a href="javascript: void(0);" class="full_list_visit">نمایش همه</a>
				</div>

			';

		} else {

			$full_list_visit_link = "";

		}

		$user_list_visit_item_result = '

			<div class="lightstat_user_list">

				<span class="lightstat_user_list_title">فهرست کاربران</span>

				'.$user_list_visit_item.$full_list_visit_link.'

			</div>

		';

		$border_none_user = "";

	} else {

		$user_list_visit_item_result = "";
		$border_none_user = "border_none_user";

	}

	if(isset($theme_light)) {

		$theme_type = "lightstat_light_theme";

	} else {

		$theme_type = "";

	}

	$result_lighstat = '

		<div class="lightstat_main '.$theme_type.'">
			
			<div id="lightstat_main_get_info">

				<div class="lightstat_body '.$border_none_user.'">

					<div class="lightstat_progress">
						'.$result_numb_percent.'
					</div>

					<div class="" style="clear: both;"></div>

					<span class="lightstat_is"> تعداد '.$numb_online_head.' آنلاین در سایت :</span>

					<div class="result_numb">'.$result_numb.'</div>

				</div>

				'.$user_list_visit_item_result.'

			</div>

		</div>

		<script>
		
			$(function() {

				var no_active_time = 6;
				var now_time = 0;

				var run_lightstat_info = true;
				let timer_lightstat;
				
				function update_stat() {

					if(now_time >= no_active_time) {
						
						return;
					
					}

					$(".lightstat_main").load(window.location.pathname+" #lightstat_main_get_info");
				
				}

				document.onmousemove = function() {
					
					now_time = 0;
				
				};

				function update_lightstat() {
					
					if(run_lightstat_info) {
						
						update_stat();
						now_time++;

						timer_lightstat = setTimeout(update_lightstat, 20000);
					
					}
				
				}

				$(document).on("mouseover", ".lightstat_main", function() {
					
					run_lightstat_info = false;
					
					clearTimeout(timer_lightstat);

				});

				$(document).on("mouseleave", ".lightstat_main", function() {

					run_lightstat_info = true;

					timer_lightstat = setTimeout(update_lightstat, 20000);
				
				});

				update_lightstat();

				$(document).on("click", ".full_list_visit", function() {

					$(".lightstat_user_list_item").css({"display": "flex"});

					$(".full_list_visit_bg").hide();

				});

			}); 
	
		</script>

	';

	$dle_api->save_to_cache("cache_lighstat", $result_lighstat); 

	echo $result_lighstat;

} else {

	echo $cache_lighstat;

}

?>